"use strict";
exports.__esModule = true;
var react_1 = require("react");
exports["default"] = (function (backgroundColor, highlightColor, highlightSize, active) {
    if (highlightSize === void 0) { highlightSize = '400px'; }
    if (active === void 0) { active = true; }
    var _a = (0, react_1.useState)(false), cursorInItem = _a[0], setCursorInItem = _a[1];
    var _b = (0, react_1.useState)([0, 0]), cursorPos = _b[0], setCursorPos = _b[1];
    var elementRef = (0, react_1.useRef)();
    (0, react_1.useEffect)(function () {
        if (active) {
            var handleMouseEnter_1 = function () {
                setCursorInItem(true);
            };
            var handleMouseLeave_1 = function () {
                setCursorInItem(false);
            };
            if (elementRef.current) {
                elementRef.current.addEventListener('mouseenter', handleMouseEnter_1);
                elementRef.current.addEventListener('mouseleave', handleMouseLeave_1);
                return function () {
                    var _a, _b;
                    (_a = elementRef.current) === null || _a === void 0 ? void 0 : _a.removeEventListener('mouseenter', handleMouseEnter_1);
                    (_b = elementRef.current) === null || _b === void 0 ? void 0 : _b.removeEventListener('mouseleave', handleMouseLeave_1);
                };
            }
        }
    }, [elementRef, active]);
    (0, react_1.useEffect)(function () {
        if (active) {
            var handleMouseMove_1 = function (e) {
                var rect = elementRef.current.getBoundingClientRect();
                var x = e.clientX - rect.x;
                var y = e.clientY - rect.y;
                var xPerc = (x / rect.width) * 100;
                var yPerc = (y / rect.height) * 100;
                setCursorPos([xPerc, yPerc]);
            };
            if (elementRef.current) {
                if (cursorInItem) {
                    elementRef.current.addEventListener('mousemove', handleMouseMove_1);
                }
                else {
                    elementRef.current.removeEventListener('mousemove', handleMouseMove_1);
                }
                return function () {
                    var _a;
                    (_a = elementRef.current) === null || _a === void 0 ? void 0 : _a.removeEventListener('mousemove', handleMouseMove_1);
                };
            }
        }
    }, [elementRef, cursorInItem, active]);
    return [
        elementRef,
        cursorInItem
            ? "radial-gradient(circle at ".concat(cursorPos[0], "% ").concat(cursorPos[1], "%, ").concat(highlightColor, " 0%, ").concat(backgroundColor, " ").concat(highlightSize, ")")
            : backgroundColor,
    ];
});
